unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button2: TButton;
    StatusBar1: TStatusBar;
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses tsutil;

procedure TForm1.Button2Click(Sender: TObject);
var s:PWTS_SESSION_INFO;
    si:WTS_SESSION_INFO;
    c:dword;
    i:integer;
    res:boolean;
    msg:string;
    buff:LPTSTR;
    buffSize:dword;
begin
  msg:='some (unknown?) error';
  StatusBar1.SimpleText:='refreshing...';
  res:=WTSEnumerateSessions(WTS_CURRENT_SERVER_HANDLE, 0, 1, s, c);
  if res then
  begin
    for i:=1 to c do
    begin
      si:=PWTS_SESSION_INFO(integer(s)+(i-1)*sizeof(WTS_SESSION_INFO))^;
      if si.State=WTSActive then
      begin
        WTSQuerySessionInformation(WTS_CURRENT_SERVER_HANDLE, si.SessionId, WTSUserName, buff, buffSize);
        msg:='Active user=<'+buff+'> with sessionID=<'+inttostr(si.SessionId)+'>';
        WTSFreeMemory(buff);
        break;
      end;
    end;
    WTSFreeMemory(s);
  end;
  StatusBar1.SimpleText:='done. error code: '+inttostr(GetLastError);
  showmessage(msg);
end;

end.
